<style type="text/css">
.bpvm-about-wrap {
  /*font-family: "verdana", sans-serif, serif;*/
}

.bpvm-about-wrap ul,
.bpvm-about-wrap li,
.bpvm-about-wrap p {

  font-size: 14px;
  line-height: 2em;

}

.bpvm-about-wrap h2 {

  margin: 0;
  padding: 0;
  text-align: left !important;
}

.bpvm-about-wrap small {
  font-size: 12px;
}

.developer-info {

  font-size: 16px;
}

.welcome-hr {
  border: 0px;
  border-bottom: 1px solid #cccccc;
}


.more-addon {
  display: flex;
  vertical-align: top;
}

.addon-list {
  font-weight: 400;
  padding-left: 0;
  margin: 0;
}

.addon-list .version {
  display: inline-block;
  padding: 0 12px;
  color: #FFF;
  background: lightskyblue;
  margin: 0 6px;
  border-radius: 12px;
  display: none;
}

.addon-list li {
  list-style-type: decimal;
  display: flex;
  justify-content: flex-start;
  align-items: center;
  /* flex-wrap: wrap; */
  gap: 0 12px;
}

.addon-list li span:nth-of-type(1) {
  flex-basis: 300px;
  font-weight: bold;
}

.addon-list li p {
  flex-basis: 500px;
}

.addon-list .btn-container {
  display: flex;
  justify-content: center;
  align-items: flex-end;
  gap: 0 12px;
}

.btn-addon {
  display: inline-block;
  padding: 6px 12px;
  text-decoration: none;
  border-radius: 4px;
  color: #FFF;
  font-weight: bold;
}

.btn-addon.btn--download {
  background: yellowgreen;
}

.btn-addon.btn--documentation {
  background: lightskyblue;
}
</style>

<div class="wrap bpvm-about-wrap">

  <h2>BWL Pro Voting Manager</h2>

  <p class="developer-info">

    By Md. Mahbub Alam Khan<br>

    Web Site: <a href="https://bluewindlab.net" target="_blank">www.bluewindlab.net</a><br>

  </p>

  <hr class="welcome-hr" />

  <?php


  $bpvm_addons = [

    [
      'title' => 'Undo My Vote Addon',
      'info' => 'This addon automatically added a custom undo button to the voting box, so user can easily undo their vote. Also, admin users can limit the number of undo for the users vote.',
      'version' => '1.0.0',
      'doc' => "https://xenioushk.github.io/docs-plugins-addon/bpvm-addon/umva/index.html",
      'download' => 'https://codecanyon.net/item/undo-my-vote-addon-for-bwl-pro-voting-manager/32986128'
    ],

    [
      'title' => 'User Vote Tracker',
      'info' => 'This Addon allows you to display custom voting report page any where of your site using shortcode. Addon automatically added a custom report page in admin panel, so user can easily track their previous voted items.',
      'version' => '1.0.1',
      'doc' => "https://xenioushk.github.io/docs-plugins-addon/bpvm-addon/uvta/index.html",
      'download' => 'https://github.com/xenioushk/user-vote-tracker/archive/refs/heads/main.zip'
    ],

    [
      'title' => 'WooCommerce Product Voting Addon',
      'info' => 'You can add unlimited number of knowledge base post as product knowledgebase items and using drag drop feature sort them according to your choice.',
      'version' => '1.0.4',
      'doc' => "https://xenioushk.github.io/docs-plugins-addon/bpvm-addon/wpva/index.html",
      'download' => 'https://github.com/xenioushk/woocommerce-product-voting-addon/archive/refs/heads/main.zip'
    ]

  ]

  ?>

  <table class="plugin-info-wrapper">
    <tr>
      <td class="more-addon">
        <ol class="addon-list">

          <?php foreach ($bpvm_addons as $addon) : ?>

          <li>

            <span><?php echo $addon['title'] ?></span>

            <?php echo (isset($addon['info'])) ? "<p>" . $addon['info'] . "</p>" : ""; ?>


            <span class="version"><?php echo $addon['version'] ?></span>
            <span class="btn-container">
              <a href="<?php echo $addon['download'] ?>" target="_blank" class="btn-addon btn--download">Download</a>
              <a href="<?php echo $addon['doc'] ?>" target="_blank"
                class="btn-addon btn--documentation">Documentation</a>
            </span>
          </li>
          <?php endforeach ?>

        </ol>

      </td>

    </tr>
  </table>

</div>